/*
 *      ISIS release V1.1, Dec. 1988
 *      Export restrictions apply
 */
/*
 *      This module implements the (experimental) client-client bypass mechanism
 *      Used if ISIS was compiled with -DBYPASS
 *      Performance factor of 5-10 improvement, but may be buggy
 */

#include "isis.h"

#ifdef	BYPASS

qnode   *bypass_queue;

struct bc_node
{
	int	bc_seqn;
	int	bc_ndests;
        int     bc_flag;
	ginfo	*bc_gip;
};

struct	by_info
{
	int	by_viewid;
	int	by_myseqn;
	int	by_bseq[PG_ALEN];
};

typedef	struct by_info	by_info;

#define	    FTYPE_BYINFO   FTYPE_LONG

typedef	struct bc_node bc_node;

adesc	bcn_ad	=	{ sizeof(bc_node), 0, 32};

#define	bc_alloc()	(bc_node*)mallocate(&bcn_ad)
#define bc_free(bc)	mdeallocate((char*)bc,&bcn_ad)

static	ginfo *active_gip;          /* Set if there is a unique active group */
static  active_count;               /* Count of active groups */
static  condition want_active;      /* Queue for waiting in make_active */
static  isis_nblock;

#define A_SNDBCAST    0
#define A_SNDMSG      1
#define A_RCVBCAST    2


bypass_init()
  {
        int bypass_cntl(), bypass_flush(), bypass_inactive();
        isis_entry(GENERIC_BYCNTL, bypass_cntl, "bypass_cntl");
        isis_entry(GENERIC_BYFLSH, bypass_flush, "bypass_flush");
        isis_entry(GENERIC_BYINACTIVE, bypass_inactive, "bypass_inactive");
	bypass_queue = qu_null();
  }

/* ISIS protos->local bypass facility */
bypass_cntl(mp)
  register message *mp;
  {
        if(--isis_binhibit == 0)
            isis_state &= ~ISIS_BINHIBIT;
	else if(isis_binhibit < 0)
	    panic("bypass_cntl");
        nullreply(mp);
  }

/* ISIS protos sometimes piggybacks bypass flags on other messages */
bypass_piggyback(mp)
  register message *mp;
  {
        register *bypass_info;
        if(msg_getfield(mp, SYSFLD_BYPASS, 1, (int*)0))
            isis_state |= ISIS_BINHIBIT;
        else if(isis_binhibit == 0)
            isis_state &= ~ISIS_BINHIBIT;
  }

message *
bypass_send(protocol, dests, msg, nwant)
  register address *dests;
  register message *msg;
  {
        message *collect_replies();
        register groupview *bv;
        register ginfo *gip;
        register address *ap, *dp;
        register entry, myrank;
	register bc_node *bc = 0;
        int msgid, bypass_sent(), (*routine)() = NULLROUTINE;
        address *msg_setdests();
        int exmode = 0, sngl_dest = 0;
        extern ISIS_MSGID, bc_countdown(), ms_countdown();

        if((isis_state&ISIS_INIT) == 0)
            panic("attempt to broadcast failed: must call isis_init first!");
        switch(protocol)
        {
          case CL_FBCAST_EX:
          case CL_CBCAST_EX:
              ++exmode;

          case CL_FBCAST:
          case CL_CBCAST:
              break;

          default:
              return(0);
        }
        if((isis_state&ISIS_BINHIBIT) || !addr_isnull(dests[1]))
            goto pbchk;
        if(dests[0].type == ISAGID && (gip = map_gaddr(dests[0])))
        {
            /* Case of bcast to a group to which I belong */
            bv = gip->gi_bypassview;
            if(bv == 0 || (bv->gv_flag&PG_VALID) == 0)
                goto pbchk;
            myrank = 0;
            for(ap = bv->gv_members; !addr_isnull(*ap); ap++)
                if(addr_cmp(*ap, my_address) == 0)
                    break;
                else
                    ++myrank;
            if(myrank == bv->gv_nmemb)
                goto pbchk;
	    make_active(gip, A_SNDBCAST);
            dp = ap = msg_setdests(msg, bv->gv_members);
        }
        else if(dests[0].type != ISAPID)
            goto pbchk;
        else
	{
            /* Case of bcast to a single process... member of group to which I belong? */
	    if(gip = active_gip)
            {
                /* active_gip is set if there is only one that is active */
                if((bv = gip->gi_bypassview) == 0)
		    goto pbchk;
		if(!pg_ismemb(bv, dests[0]))
		    gip = 0;
	    }
	    if(gip == (ginfo*)0)
                for(gip = isis_groups; gip; gip = gip->gi_next)
	        {
                    if(gip == active_gip)
                        continue;
                    if((bv = gip->gi_bypassview) == 0)
		        continue;
		    if(pg_ismemb(bv, dests[0]))
		        break;
	        }
	    if(gip == (ginfo*)0)
		goto pbchk;
	    ++sngl_dest;
            dp = ap = msg_setdests(msg, dests);
	    make_active(gip, A_SNDMSG);
	}
        if((bv = gip->gi_bypassview) == 0)
	    panic("no group view defined! bypass_send");
        msgid = isis_ctp->task_msgid;
        if(msgid == 0)
            msgid = (ISIS_MSGID += 2)+1;
        msg_setsender(msg, isis_ctp->task_addr);
        entry = dests[0].entry;
        while(!addr_isnull(*ap))
            ap++->entry = entry;
        msg_insertfield(msg, SYSFLD_MSGID, (char*)&msgid, FTYPE_LONG, sizeof(int));
        msg_insertfield(msg, SYSFLD_BYINFO, (char*)dests, FTYPE_ADDRESS, sizeof(address));
	if(!sngl_dest)
	{
	    bc = bc_alloc();
	    bc->bc_gip = gip;
	    bc->bc_seqn = ++gip->gi_bseqns[myrank];
print("intercl_send: bc %x seqn %d (myrank %d)\n", bc, bc->bc_seqn, myrank);
	    bc->bc_ndests = bv->gv_nmemb;
            bc->bc_flag = 1;
	    routine = bc_countdown;
	}
        else
        {
	    bc = bc_alloc();
	    bc->bc_gip = gip;
            bc->bc_flag = 0;
            routine = ms_countdown;
        }
	begin
	{
	    static by_info byi;
	    register *bseqns, *lbseqns;
	    msg_insertfield(msg, SYSFLD_BYGRP, (char*)&gip->gi_gaddr, FTYPE_ADDRESS, sizeof(address));
	    byi.by_viewid = bv->gv_viewid;
	    byi.by_myseqn = gip->gi_myseqn;
            bcopy(gip->gi_bseqns, byi.by_bseq, bv->gv_nmemb<<2);
	    bseqns = lbseqns = (int*)msg_insertfield(msg, SYSFLD_BYPASS, (char*)&byi, FTYPE_BYINFO, sizeof(byi));
            if(gip->gi_departed >= 0)
	    {
                /* Case of viewid n sending to viewid (n+1) */
                bseqns += gip->gi_departed;
                lbseqns += bv->gv_nmemb;
                while(bseqns != lbseqns)
                {
                    bseqns[0] = bseqns[1];
                    bseqns++;
                }
		*bseqns = 0;
	    }
	}
        if(isis_ctp->task_act)
            msg_insertfield(msg, SYSFLD_ACT, (char*)&act_map[isis_ctp->task_act].act_id,
                            FTYPE_ADDRESS, sizeof(address));
        intercl_send(exmode, msg, dp, routine, bc);
        if(nwant)
            return(collect_replies(msgid, nwant));
        return((message*)-1);
  pbchk:
        /* Before I can send a CBCAST to protos, must wait for activity to end */
	do_check_pbuf(nwant);
	return((message*)0);
  }

pg_ismemb(gv, addr)
  register groupview *gv;
  address addr;
  {
	address *ap;
	if(gv == 0 || (gv->gv_flag&PG_VALID) == 0)
	    return(0);
	for(ap = gv->gv_members; !addr_isnull(*ap); ap++)
	    if(addr_cmp(*ap, addr) == 0)
		return(1);
	return(0);
  }

/* intercl_send informs us that <bc> "made it" to <dest> */
bc_countdown(dest, bc)
  address dest;
  register bc_node *bc;
  {
	if(--bc->bc_ndests < 0)
	    panic("bc countdown");
	if(bc->bc_ndests == 0)
	{
	    if(bc->bc_seqn != -1 && ++bc->bc_gip->gi_myseqn != bc->bc_seqn)
	        panic("bypass_countdown %d %d\n", bc->bc_gip->gi_myseqn, bc->bc_seqn);
            if(bc->bc_flag)
	        make_inactive(bc->bc_gip, A_SNDBCAST);
	    bc_free(bc);
	}
  }

/* Version for point-to-point messages */
ms_countdown(dest, bc)
  address dest;
  register bc_node *bc;
  {
	make_inactive(bc->bc_gip, A_SNDMSG);
	bc_free(bc);
  }

bypass_recv(byaddr, mp)
  address byaddr;
  register message *mp;
  {
        register *bseqn, *gp, n;
        register ginfo *gip;
        register groupview *gv;
	register by_info *byi;
        int hisrank = -1, myrank = -1, sngl_dest = 0, gotone;
	address sender, *gaddr;
print("bypass recv "); pmsg(mp);
        if(bypass_waitq)
        {
            msg_increfcount(mp);
print("must wait\n");
	    pg_add_mp(bypass_waitq, byaddr, mp, msg_delete);
            return;
        }
	sender = msg_getsender(mp);
        begin
        {
            register address *gaddr = (address*)msg_getfield(mp, SYSFLD_BYGRP, 1, NULLARG);
	    register address *ap;
	    if((gip = map_gaddr(*gaddr)) == (ginfo*)0 ||
	       (gv = act_blocked? gip->gi_mutexview: gip->gi_view) == 0 ||
               (gv->gv_flag&PG_VALID) == 0 || gv->gv_viewid < gaddr->entry)
	    {
print("must wait\n");
	        msg_increfcount(mp);
	        pg_add_mp(bypass_waitq = qu_null(), byaddr, mp, msg_delete);
	        return;
	    }
            n = 0;
	    for(ap = gv->gv_members; !addr_isnull(*ap); ap++, n++)
		if(addr_cmp(*ap, sender) == 0)
		    hisrank = n;
		else if(addr_ismine(*ap))
		    myrank = n;
            if(hisrank < 0 || myrank < 0)
	        panic("bypass_recv: rank!");
	}
        byi = (by_info*)msg_getfield(mp, SYSFLD_BYPASS, 1, 0);
	bseqn = byi->by_bseq;
	if(byi->by_viewid != gv->gv_viewid)
	    panic("bypass_recv: vid %d != expected %d", byi->by_viewid, gv->gv_viewid);
	if(byaddr.type == ISAGID && (gip = map_gaddr(byaddr)))
	{
            gp = gip->gi_bseqns;
            if(!addr_ismine(sender))
            {
                register qnode *qp;
		qp = pg_find(gip->gi_byprocs, sender);
		if(qp == 0)
		{
		    qp = pg_add_qu(gip->gi_byprocs, sender, qu_null());
		    qp->qu_seqn = 0;
		}
                else if(qp->qu_seqn >= bseqn[hisrank])
                {
	            print("... duplicate, received due to failure flush\n");
	            return;
                }
                else
                    bypass_gcollect(qp, gip, sender, byi->by_myseqn);
		/* Keep a copy for retransmission after a failure, if necessary */
                msg_increfcount(mp);
                qu_add_mp(qp->qu_queue, bseqn[hisrank], mp, msg_delete)->qu_flag = 0;
            }
	}
	else if(byaddr.type == ISAPID && addr_ismine(byaddr))
	    ++sngl_dest;
	else
	    panic("bypass_recv: unknown addr");
	if(bseqn[hisrank] < 0)
	    bseqn[hisrank] = -bseqn[hisrank];
        gp = gip->gi_bseqns;
        for(n = 0; n < gv->gv_nmemb; n++)
	    if(*bseqn++ > *gp++ && !(n == myrank || n == hisrank))
	    {
                /* This message needs to wait for something */
	        msg_increfcount(mp);
	        qu_add_mp(gip->gi_bypassq, hisrank, mp, NULLROUTINE);
print("must wait for something else\n");
	        return;
	    }
        if(sngl_dest)
        {
print("isis_gotmsg: sngl_dest\n");
            isis_gotmsg(mp, BYP_DONTCHECK);
            return;
        }
print("by_makeactive: group %x mp %x\n", gip, mp);
        by_makeactive(gip, mp);
	gip->gi_bseqns[hisrank] = byi->by_bseq[hisrank];
print("isis_gotmsg: group dest\n");
        isis_gotmsg(mp, BYP_DONTCHECK);
        do
        {
	    register qnode *qp, *nqp;
	    gotone = 0;
	    for(qp = gip->gi_bypassq->qu_next; qp != gip->gi_bypassq; qp = nqp)
	    {
	        nqp = qp->qu_next;
	        hisrank = qp->qu_name;
	        mp = qp->qu_msg;
	        byi = (by_info*)msg_getfield(mp, SYSFLD_BYPASS, 1, 0);
	        bseqn = byi->by_bseq;
	        gp = gip->gi_bseqns;
	        for(n = 0; n < gv->gv_nmemb; n++)
		    if(*bseqn++ > *gp++ && !(n == qp->qu_name || n == myrank))
		        break;
	        if(n == gv->gv_nmemb)
	        {
		    sngl_dest = (((address*)msg_getfield(mp, SYSFLD_BYINFO, 1, 0))->type == ISAPID);
		    if(gip->gi_bseqns[hisrank] < byi->by_bseq[hisrank])
		    {
			gip->gi_bseqns[hisrank] = byi->by_bseq[hisrank];
		        ++gotone;
		    }
                    if(!sngl_dest)
                        by_makeactive(gip, mp);
		    isis_gotmsg(mp, BYP_DONTCHECK);
		    qu_free(qp);
	        }
	    }
        }
        while(gotone);
  }
    
/* Sender informs me: ``ok to delete up through ....'' */
bypass_gcollect(qp, gip, sender, seqn)
  register ginfo *gip;
  address sender;
  register seqn;
  register qnode *qp;
  {
        register qnode *np, *nnp;
print("Got a FLUSH message, gcollect up to %d, currently %d\n", seqn, qp->qu_seqn);
        if(qp->qu_seqn >= seqn)
	    return;
        qp->qu_seqn = seqn;
        for(np = qp->qu_queue->qu_next; np != qp->qu_queue && np->qu_seqn <= seqn; np = nnp)             
        {
print("found a node %x: seqn %d flag %d msg %x\n", np, np->qu_seqn, np->qu_flag, np->qu_msg);
	    if(np->qu_flag)
	        make_inactive(gip, A_RCVBCAST);
	    nnp = np->qu_next;
	    qu_free(np);
        }
  }

by_makeactive(gip, mp)
  register ginfo *gip;
  register message *mp;
  {
        address sender;
        register qnode *qp, *mqp;
	sender = msg_getsender(mp);
	if(addr_ismine(sender))
            return;
	make_active(gip, A_RCVBCAST);
	if(qp = pg_find(gip->gi_byprocs, sender))
	    for(mqp = qp->qu_queue->qu_next; mqp != qp->qu_queue; mqp = mqp->qu_next)
	        if(mqp->qu_msg == mp)
	        {
	            ++mqp->qu_flag; /* ``Made active'' */
                    break;
	        }
  }

static	bypass_nblock;	/* Number of times ISIS_BLOCK was set */
static  want_do_check;
condition want_makeactive;
static	bypass_doflush();

/* Active group is equivalent to non-empty pbuf */
do_check_pbuf(nwant)
  {
	if(active_count == 0)
	    return;
	++bypass_nblock;
	isis_state |= ISIS_BLOCK;
        ++want_do_check;
	if(nwant == 0)
	    isis_state |= ISIS_DRAINPBUF;
	do
            t_wait_l(&want_active, "do_check_pbuf:want_active");
	while(active_count);
	isis_state &= ~ISIS_DRAINPBUF;
        if(--want_do_check == 0)
	    t_sig_all(&want_makeactive, 0);
	if(--bypass_nblock == 0)
	    isis_state &= ~ISIS_BLOCK;
  }

make_active(gip, how)
  register ginfo *gip;
  register how;
  {
        register ginfo *agip = gip;
        /* For fairness.... */
print("make_active: gip %x how %d\n", gip, how);
	if(isis_ctp != &isis_scheduler)
	{
            if(want_do_check)
                t_wait_l(&want_makeactive, "make_active:want_makeactive");
            if(t_waiting(&want_active))
                t_wait_l(&want_active, "make_active:want_active");
	}
        forever switch(how)
	{
          case A_SNDBCAST:
	    if(active_count == 0)
	    {
	        ++active_count;
	        ++gip->gi_activebsnd;
	        active_gip = gip;
	        return;
	    }
	    if(active_count == 1 && gip == active_gip && (gip->gi_activebrcv+gip->gi_activemsg) == 0)
	    {
	        ++gip->gi_activebsnd;
	        return;
	    }
	    t_wait(&want_active);
	    continue;
          case A_SNDMSG:
	    if(active_count == 0)
	    {
	        ++active_count;
	        ++gip->gi_activemsg;
	        active_gip = gip;
	        return;
	    }
	    if(active_count == 1 && gip == active_gip && gip->gi_activebrcv == 0)
	    {
	        ++gip->gi_activemsg;
	        return;
	    }
	    t_wait(&want_active);
	    continue;

          case A_RCVBCAST:
	    if(active_count == 0)
	    {
	        ++active_count;
	        ++gip->gi_activebrcv;
	        active_gip = gip;
	        return;
	    }
	    if(active_count == 1 && gip == active_gip)
	    {
	        ++gip->gi_activebrcv;
	        return;
	    }
	    active_gip = 0;
	    if(gip->gi_activebsnd+gip->gi_activemsg+gip->gi_activebrcv == 0)
	        ++active_count;
	    ++gip->gi_activebrcv;
	    return;
        }
  }

make_inactive(gip, how)
  register ginfo *gip;
  register how;
  {
print("make_inactive: gip %x how %d\n", gip, how);
        switch(how)
        {
            address dests[PG_ALEN];
            register message *mp;
            register address *ap, *dp;
            register groupview *gv;

          case A_SNDBCAST:
	    if(--gip->gi_activebsnd < 0)
	        panic("make_inactive (sndbcast): wasn't active");
            mp = msg_gen("%d,%a", gip->gi_myseqn, gip->gi_gaddr);
            gv = gip->gi_bypassview;
            ap = dests;
	    dp = gv->gv_members;
            while(!addr_isnull(*dp))
	    {
                *ap = *dp++;
                ap->entry = GENERIC_BYINACTIVE;
                ++ap;
            }
            *ap = NULLADDRESS;
            msg_setdests(mp, dests);
	    intercl_send(TRUE, mp, dests, NULLROUTINE, NULLARG);
            msg_delete(mp);
	    break;
          case A_SNDMSG:
	    if(--gip->gi_activemsg < 0)
	        panic("make_inactive (sndmsg): wasn't active");
	    break;
          case A_RCVBCAST:
	    if(--gip->gi_activebrcv < 0)
	        panic("make_inactive (rcvbcast): wasn't active");
	    break;
        }
        if(gip->gi_activebsnd+gip->gi_activemsg+gip->gi_activebrcv == 0)
        {
            if(--active_count > 1)
                return;
            if(active_count == 0)
                active_gip = 0;
            else if(active_count == 1)
	    {
	        for(gip = isis_groups; gip; gip = gip->gi_next)
                    if(gip->gi_activebsnd+gip->gi_activemsg+gip->gi_activebrcv)
                    {
                        active_gip = gip;
                        break;
                    }
                if(active_gip == 0)
                    panic("make_inactive count 1 but can't find gip");
	    }
            t_sig_all(&want_active, 0);
        }
  }

bypass_inactive(mp)
  register message *mp;
  {
        address gaddr, sender;
        register qnode *qp;
        register ginfo *gip;
        int seqn;
        msg_get(mp, "%d,%a", &seqn, &gaddr);
        gip = map_gaddr(gaddr);
        if(gip == (ginfo*)0)
            panic("bypass inactive: unknown gaddr");
	sender = msg_getsender(mp);
	if(qp = pg_find(gip->gi_byprocs, sender))
	    bypass_gcollect(qp, gip, sender, seqn);
  }

/* First chance to check: when message received from protos */
bypass_precheck(mp)
  register message *mp;
  {
        register sys_groupview *npg;
        register ginfo *gip;
	register groupview *bv;
        groupview *isis_gv_alloc();

        if((npg = (sys_groupview*)msg_getfield(mp, CL_NEWVIEW, 1, (int*)0)) == (sys_groupview*)0 ||
            (gip = map_gaddr(npg->pg_gid)) == (ginfo*)0)
                return;
        bv = gip->gi_protosview;
        if(bv == 0)
	    gip->gi_protosview = bv = isis_gv_alloc();
        isis_pg_copy(npg, bv);
print("This is "); paddr(my_address); print(" in bypass_precheck\n");
	intercl_newview(bv);
  }

/* Second chance to check: about to install new view */
bypass_checkview(gip, npg)
  register sys_groupview *npg;
  register ginfo *gip;
  {
        register groupview *bv;
	register index;
print("This is "); paddr(my_address); print(" in bypass_checkview\n");
        bv = gip->gi_bypassview;
	if(bv == 0)
	{
            groupview *isis_gv_alloc();
	    gip->gi_bypassview = bv = isis_gv_alloc();
            index = isis_pg_copy(npg, bv);
	}
        else if(bv->gv_viewid >= npg->pg_viewid)
	    return;
	gip->gi_departed = index = isis_pg_copy(npg, bv);
	gip->gi_bypassviewid = bv->gv_viewid; 
	if(bv->gv_nmemb > 1)
	{
	    /* Block until bypasscount counts up to nmemb */
	    gip->gi_bypasscount = 1; 
	    isis_state |= ISIS_BLOCK;
	    ++isis_nblock;
	    bypass_doflush(gip);
	}
	/* Departed: copy bseqns, skip entry for departed member */
	if(index >= 0)
	{
	    register *bseqns, *lbseqns;
	    scan_departed(bv->gv_departed);
	    bseqns = &gip->gi_bseqns[index];
	    lbseqns = &gip->gi_bseqns[bv->gv_nmemb];
	    while(bseqns != lbseqns)
	    {
		bseqns[0] = bseqns[1];
		bseqns++;
	    }
	    gip->gi_departed = -1;
	}
	gip->gi_bseqns[bv->gv_nmemb] = 0;
  }

/* Flush stuff from the failed process */
static
bypass_doflush(gip)
  register ginfo *gip;
  {
	register qnode *qp;
        register groupview *bv = gip->gi_bypassview;
	register address *ap;
print("bypass_doflush: I am "); paddr(my_address); print(", view "); paddrs(bv->gv_members); print("\n");
	if(!addr_isnull(bv->gv_departed) && (qp = pg_find(gip->gi_byprocs, bv->gv_departed)))
	{
	    register qnode *np;
	    for(np = qp->qu_queue->qu_next; np != qp->qu_queue; np = np->qu_next)
	    {
                register bc_node *bc;
		register address *dlist;
	        bc = bc_alloc();
                if((bc->bc_gip = map_gaddr((address*)msg_getfield(np->qu_msg, SYSFLD_BYGRP, 1, 0))) == 0)
		    panic("bypass_doflush");
                bc->bc_seqn = -1;
		dlist = msg_getdests(np->qu_msg);
                bc->bc_ndests = alist_len(dlist);
                bc->bc_flag = np->qu_flag;
		intercl_send(TRUE, np->qu_msg, dlist, bc_countdown, bc);
	    }
	    qu_free(qp);
	}
	for(ap = bv->gv_members; !addr_isnull(*ap); ap++)
	    if(!addr_ismine(*ap))
		if(intercl_wantflush(*ap, bv->gv_gaddr) == -1)
                    /* Dead men tell no lies */
		    if(++gip->gi_bypasscount == bv->gv_nmemb)
		    {
			bypass_unblock(gip);
			return;
		    }
	cbcast_l("x", bv->gv_gaddr, GENERIC_BYFLSH, "%a,%d", bv->gv_gaddr, bv->gv_viewid);
	t_wait_l(&gip->gi_bypasswait, "bypass_checkview:do flush");
  }

bypass_unblock(gip)
  register ginfo *gip;
  {
print("*** bypass_unblock was called!\n");
        if(--isis_nblock)
            isis_state &= ~ISIS_BLOCK;
        if(t_waiting(&gip->gi_bypasswait))
	    t_sig(&gip->gi_bypasswait, 0);
	intercl_unblock(gip->gi_bypassview, gip->gi_gaddr);
  }

/* Reception of flush messages */
bypass_flush(mp)
  register message *mp;
  {
	address gaddr;
	int vid;
	register ginfo *gip;
        msg_get(mp, "%a,%d", &gaddr, &vid);
print("got flush message for "); paddr(gaddr); print(", viewid %d\n", vid);
pmsg(mp);
        gip = map_gaddr(gaddr);
        if(gip == (ginfo*)0)
	    panic("bypass flush: unknown gaddr");
	if(vid == -1 || vid == gip->gi_bypassviewid)
	{
print("... bypasscount %d bypassview->gv_nmemb %d\n", gip->gi_bypasscount, gip->gi_bypassview->gv_nmemb);
	    if(++gip->gi_bypasscount == gip->gi_bypassview->gv_nmemb)
	         bypass_unblock(gip);
	}
	else
	    panic("unexpected flush message vid %d bypassvid %d", vid, gip->gi_bypassviewid);
  }

/* This code would run slowly, but the lists are usually almost empty */
static
scan_departed(rip)
  address rip;
  {
        register ginfo *gip;
        register qnode *qp, *nqp;
	for(gip = isis_groups; gip; gip = gip->gi_next)
        {
	    register groupview *gv = gip->gi_bypassview;
	    register address *dp;
            int myrank = 0, hisrank = 0;
            if(gv == 0)
                 continue;
            for(dp = gv->gv_members; !addr_isnull(*dp); dp++)
                if(addr_cmp(*dp, my_address) == 0)
                    break;
                else
                    ++myrank;
            for(qp = gip->gi_bypassq->qu_next; qp != gip->gi_bypassq; qp = nqp)
            {
                register *bseqn, *gp;
		register message *mp;
		register n;
		register by_info *byi = (by_info*)msg_getfield(mp, SYSFLD_BYPASS, 1, 0);
                nqp = qp->qu_next;
                hisrank = qp->qu_name;
                mp = qp->qu_msg;
		if(byi->by_viewid != gip->gi_bypassviewid)
		    panic("scan_departed: viewid %d != expected viewid %d\n", byi->by_viewid, gip->gi_bypassviewid);
                bseqn = byi->by_bseq;
                gp = gip->gi_bseqns;
                for(n = 0; n < gv->gv_nmemb; n++)
                    if(*bseqn++ > *gp++ && !(n == qp->qu_name || n == myrank))
		        if(addr_isequal(rip, gv->gv_members[n]))
			{
			    qu_free(qp);
			    break;
			}
            }
        }
  }

message *
collect_replies(msgid, nwant)
  {
        register message *rmp = msg_newmsg();
        isis_ctp->task_msgid = msgid;
        while(nwant--)
        {
            register message *mp = (message*)t_wait_l(&isis_ctp->task_mwant, "isis system: collecting bcast replies");
            msg_addmsg(rmp, FLD_ANSW, mp);
        }
        isis_ctp->task_msgid = 0;
        return(rmp);
  }

by_dump()
  {
        register ginfo *gip;
	for(gip = isis_groups; gip; gip = gip->gi_next)
            if(qu_head(gip->gi_byprocs))
  	        break;
	if(gip)
	{
	    register qnode *qp, *np;
            print("\nBypass procs: %d active groups\n", active_count);
	    for(gip = isis_groups; gip; gip = gip->gi_next)
            {
                if(qu_head(gip->gi_byprocs) == 0)
                    continue;
                print("  Group "); paddr(gip->gi_gaddr);
                if(gip->gi_activebsnd+gip->gi_activemsg+gip->gi_activebrcv)
                    print("<< active >>\n");
		print("\n");
                for(qp = gip->gi_byprocs->qu_next; qp != gip->gi_byprocs; qp = qp->qu_next)
	        {
                    print("  ...Sender ");
                    paddr(qp->qu_pname);
                    print(", Seqn %d: ", qp->qu_seqn);
                    for(np = qp->qu_queue->qu_next; np != qp->qu_queue; np = np->qu_next)
                        print("[seqn %d/%d: %x] ", np->qu_seqn, np->qu_flag, np->qu_msg);
		    print("\n");
	        }
            }
	}
  }
#else
bypass_init()
  {}

bypass_piggyback(mp)
  {}

bypass_send()
  { return(0); }

bypass_precheck()
  {}

bypass_checkview()
  {}

bypass_inactive()
  {}

bypass_unblock()
  {}

bypass_flush()
  {}


bypass_recv()
  { panic("bypass_recv: why was I called?"); }

by_dump()
  { }
#endif
